# Cloud Storage

The following subsections list the Google identity and access management (IAM) permissions granted via Compute Storage access shortcuts.

Use this information when [requesting Google Cloud Access permissions](/integrations/resource-integrations/google-cloud.md).

## Read (bucket)

Read (bucket) grants the following IAM permissions for the bucket and any contained objects:

```typescript
          storage.objects.get
          storage.objects.list
          storage.buckets.get
          storage.buckets.listEffectiveTags
          storage.buckets.listTagBindings
          storage.multipartUploads.list
          storage.multipartUploads.listParts
```

## Read (object)

Read (object) grants the following IAM permissions for the object and any child objects:

```typescript
          storage.objects.get
          storage.objects.list
          storage.multipartUploads.list
          storage.multipartUploads.listParts
```

## Write (bucket)

Write (bucket) grants the following IAM permissions for the bucket and any contained objects:

```typescript
          storage.objects.get
          storage.objects.list
          storage.buckets.get
          storage.buckets.listEffectiveTags
          storage.buckets.listTagBindings
          storage.buckets.createTagBinding
          storage.buckets.delete
          storage.buckets.deleteTagBinding
          storage.buckets.update
          storage.objects.create
          storage.objects.delete
          storage.objects.update
          storage.multipartUploads.abort
          storage.multipartUploads.create
          storage.multipartUploads.list
          storage.multipartUploads.listParts
```

## Write (object)

White (object) grants the following IAM permissions for the object and any child objects:

```typescript
          storage.objects.get
          storage.objects.list
          storage.objects.create
          storage.objects.delete
          storage.objects.update
          storage.multipartUploads.abort
          storage.multipartUploads.create
          storage.multipartUploads.list
          storage.multipartUploads.listParts
```

## Admin (bucket)

Admin (bucket) grants the `storage.admin` predefined role for the bucket and any contained objects.

## Admin (object)

Admin (object) grants the `storage.objectAdmin` predefined role for the object and any child objects.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.p0.dev/integrations/resource-integrations/google-cloud/permissions-reference/cloud-storage.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
